﻿using Monocle;
using System;
using System.Reflection;

namespace Celeste.Mod.MorePieEndings
{
    public class MorePieEndings : EverestModule
    {

        public override Type SettingsType => null;

        public override void Load()
        {
            On.Celeste.CS08_Ending.OnBegin += ModOnBegin;
        }

        public override void Unload()
        {
            On.Celeste.CS08_Ending.OnBegin -= ModOnBegin;
        }

        private void ModOnBegin(On.Celeste.CS08_Ending.orig_OnBegin orig, CS08_Ending self, Level level)
        {

			orig(self, level);

			FieldInfo f_endingDialog = typeof(CS08_Ending).GetField("endingDialog", BindingFlags.NonPublic | BindingFlags.Instance);
			FieldInfo f_vignette = typeof(CS08_Ending).GetField("vignette", BindingFlags.NonPublic | BindingFlags.Instance);

			string text;
			string endingDialog;
			int totalStrawberries_Safe = SaveData.Instance.TotalStrawberries_Safe;
			if (totalStrawberries_Safe < 20)
			{
				if (SaveData.Instance.Time < 36000000000)
				{
					text = "final0";
					endingDialog = "EP_PIE_RUSHED";
				}
				else
				{
					text = "final1";
					endingDialog = "EP_PIE_DISAPPOINTED";
				}
			}
			else if (totalStrawberries_Safe < 50)
			{
				text = "final2";
				endingDialog = "EP_PIE_GROSSED_OUT";
			}
			else if (totalStrawberries_Safe < 90)
			{
				text = "final3";
				endingDialog = "EP_PIE_OKAY";
			}
			else if (totalStrawberries_Safe < 150)
			{
				text = "final4";
				endingDialog = "EP_PIE_REALLY_GOOD";
			}
			else if (totalStrawberries_Safe < 175)
			{
				text = "final5";
				endingDialog = "EP_PIE_AMAZING";
			}
			else if (totalStrawberries_Safe < 202)
			{
				text = "final6";
				endingDialog = "EP_PIE_AWESOME";
			}
			else
			{
				text = "final7";
				endingDialog = "EP_PIE_GOLDEN";
			}

			Image vignette = (Image)f_vignette.GetValue(self);
			self.Remove(vignette);
			self.Add(vignette = new Image(GFX.Portraits[text]));
			vignette.Visible = false;
			vignette.CenterOrigin();
			vignette.Position = global::Celeste.Celeste.TargetCenter;
			f_vignette.SetValue(self, vignette);
			f_endingDialog.SetValue(self, endingDialog);

		}
    }
}
